<template>
  <div class="app-menu" v-cloak>
    <div class="app_icon menu-item">
      <el-dropdown @command="handleCommand" trigger="click">
        <span class="el-dropdown-link">
          <img :src="icon" width="30" heigth="30" alt="">
        </span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item
            @click.native.middle="openMenu(true)"
            command="openMenu">
            Menu
          </el-dropdown-item>
          <el-dropdown-item
            @click.native.middle="openAsana(true)"
            command="openAsana">
            Asana
          </el-dropdown-item>
          <el-dropdown-item
            @click.native.middle="openRadio"
            command="openRadio">
            Radio
          </el-dropdown-item>
          <el-dropdown-item
            @click.native.middle="openSettings(true)"
            command="openSettings">
            Settings
          </el-dropdown-item>
          <el-dropdown-item
            @click.native.middle="mainDevTools"
            command="mainDevTools">
            Dev tools
          </el-dropdown-item>
          <el-dropdown-item
            @click.native.middle="appClose"
            command="appClose">
            Quit
          </el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <el-button-group
      @click.right.native.prevent="selectDir"
      v-if="dirSelecter"
      style="position: absolute; left: 49px; top: 4px;-webkit-app-region: no-drag;">
      <el-button
        v-for="fold in pathSplit" 
        @click="changePath(fold.name,fold.findPath)" 
        size="small" 
        :type="fold.findPath === currentDir ? 'primary' : ''" :key="fold.name">
        {{fold.name}}
      </el-button>
    </el-button-group>

    <h4 v-else style="position: absolute; top: 11px; left: 44px;margin: 0;">{{ title }}</h4>

    <input
      :nwworkingdir="currentDir"
      @change="onChangePath"
      ref="dirSelecter"
      class="dir-selecter"
      type="file"
      nwdirectory
    >

    <div class="app_buttons">
      <div class="but" @click="winMinimize">
        <i>_</i>
      </div>
      <div class="but" v-if="!winOnTop" @click="winToggleOnTop">
        <i class="fa fa-hand-o-down" aria-hidden="true"></i>
      </div>
      <div class="but" v-if="winOnTop" @click="winToggleOnTop">
        <i class="fa fa-hand-o-up" aria-hidden="true"></i>
      </div>
      <div class="but" v-if="!fullscreen" @click="winToggleFullscreen">
        <i class="fa fa-square-o" aria-hidden="true"></i>
      </div>
      <div class="but" v-if="fullscreen" @click="winToggleFullscreen">
        <i class="fa fa-window-restore" aria-hidden="true"></i>
      </div>
      <div class="but" @click="winClose">
        <i class="fa fa-power-off" aria-hidden="true"></i>
      </div>
    </div>
  </div>
</template>



<script>
export default {
  name: 'app-menu',
  props: {
    title: {
      default: 'One Punch Web',
    },
    isClosableWindow: {
      default: true,
    },
    isMaximazedOnOpen: {
      default: false,
    },
  },
  data() {
    return {
      dirSelecter: false,
      icon: '/app.png',
      fullscreen: false,
      winOnTop: true,
      currentPath: "",
      currentDir: "",
      pathSplit: []
    }
  },
  computed: {},
  methods: {
    winMinimize() {
      nw.Window.get().minimize();
    },
    winToggleFullscreen() {
      this.fullscreen = !this.fullscreen;
      if (this.fullscreen) nw.Window.get().maximize()
      else nw.Window.get().unmaximize()
    },
    winToggleOnTop() {
      this.winOnTop = !this.winOnTop
      if (this.winOnTop) nw.Window.get().setAlwaysOnTop(true)
      else nw.Window.get().setAlwaysOnTop(false)
    },
    winClose() {
      win.close()
    },
    selectDir() {
      this.$refs.dirSelecter.click()
    },
    onChangePath(e) {
      const selected = this.$refs.dirSelecter.value
      this.setDir(selected)
    },
    appClose() {
      this.$confirm('This will permanently close app. Continue?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post('/close-app')
      })
    },
    openSettings(newWindow) {
      const router = this.$router || $nuxt.$router
      if (!newWindow && this.isClosableWindow) {
        router.push({ path: '/settings' })
      } else {
        this.$axios.get('/open-settings')
      }
    },
    openMenu(newWindow) {
      const router = this.$router || $nuxt.$router
      if (!newWindow && this.isClosableWindow) {
        router.push({ path: '/' })
      } else {
        this.$axios.get('/open-opw-menu')
      }
    },
    openAsana(newWindow) {
      const router = this.$router || $nuxt.$router
      if (!newWindow && this.isClosableWindow) {
        router.push({ path: '/asana' })
      } else {
        this.$axios.get('/open-asana')
      }
    },
    openRadio() {
      this.$axios.get('/open-radio')
    },
    mainDevTools() {
      this.$axios.get('/main-dev-tools')
    },
    changePath(dirName, findPath) {
      this.currentPath = self.currentDir
      this.currentDir = findPath
    },
    handleCommand(command) {
      this[command]()
    },
    setDir(currentDir) {
      this.currentDir = currentDir
      this.pathSplit = []
      const splitted = os.platform() !== 'win32'
        ? currentDir.split('/')
        : splitted = currentDir.split('\\')
      let currentPath = path.parse(currentDir).root
      this.pathSplit.push({
        name: currentPath,
        findPath: currentPath
      })
      for (let i = 1; i < splitted.length; i++) {
        if(splitted[i]) {
          currentPath += splitted[i] + (os.platform() !== 'win32' ? '/' : '\\')
          this.pathSplit.push({
            name: splitted[i],
            findPath: currentPath
          })
        }
      }
      this.currentDir = currentPath
    }
  },
  mounted() {
    if (process.client) {
      if (this.isMaximazedOnOpen) {
        this.fullscreen = true
        win.maximize()
      }
      win.on('close', () => {
        if (!this.isClosableWindow) {
          win.hide()
          return false
        } else {
          win.close(true)
        }
      })
    }
  }
}
</script>



<style lang="less" scoped>
@import "./AppMenu.less";
</style>